//+------------------------------------------------------------------+
//|                                            StepMA_sashken_v2.mq4 |
//|                                          E-mail: sashken@mail.ru |
//+------------------------------------------------------------------+

#property link      "E-mail: sashken@mail.ru"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 Aqua
#property indicator_color2 Gold
#property indicator_color3 Red
#property indicator_color4 Lime
#property indicator_color5 Magenta

//---- input parameters
extern string  TimeFrame = "Current time frame";
extern int MA=5;                    // ma period
extern int MAmode=MODE_EMA;         // ma mode
extern int MAprice=PRICE_CLOSE;     // ma price
extern double StepSizeFast=0.0015;  // points
extern double StepSizeSlow=0.0015;  // points
extern int FastSdvig=3;  //
extern int SlowSdvig=3;  //
extern int StepSmooth=1;  //
extern double StepSize=2.0;         // 2.0
extern int TotalBar=5000;  
extern bool    ArrowsOnFirstBar = true;        
//extern int HighLow=0;
//---- indicator buffers
double Line1Buffer[];
double Line2Buffer[];
double Line3Buffer[];
double Line4Buffer[];
double Line5Buffer[];
double Line6Buffer[];
double Line7Buffer[];

string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   IndicatorBuffers(7);
   SetIndexBuffer(0,Line1Buffer);
   SetIndexBuffer(1,Line2Buffer);
   SetIndexBuffer(2,Line3Buffer);
   SetIndexBuffer(3,Line4Buffer); SetIndexStyle(3, DRAW_ARROW); SetIndexArrow(3, 233);
   SetIndexBuffer(4,Line5Buffer); SetIndexStyle(4, DRAW_ARROW); SetIndexArrow(4, 234);
   SetIndexBuffer(5,Line6Buffer);
   SetIndexBuffer(6,Line7Buffer);
   indicatorFileName = WindowExpertName();
   returnBars        = TimeFrame == "returnBars";     if (returnBars)     return(0);
   timeFrame         = stringToTimeFrame(TimeFrame);
   IndicatorShortName(timeFrameToString(timeFrame)+" StepMA_sashken(Period:"+MA+", Fast:"+StepSizeFast+", Slow:"+StepSizeSlow+")");
   SetIndexLabel(0,"MA");
   SetIndexLabel(1,"StepMA fast");
   SetIndexLabel(2,"StepMA slow");
   SetIndexLabel(3,"UP signal");
   SetIndexLabel(4,"DOWN signal");
//----
   SetIndexDrawBegin(0,1);
   SetIndexDrawBegin(1,1);
   SetIndexDrawBegin(2,1);
//----
   return(0);
  }

//+------------------------------------------------------------------+
//| StepMA_sashken_v1                                                |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Line1Buffer[0] = limit+1; return(0); }
   
            if (timeFrame!=Period())
            {
               int displace = -1; if (ArrowsOnFirstBar) displace = 1;
               limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
               for (int i=limit; i>=0; i--)
               {
                   int y = iBarShift(NULL,timeFrame,Time[i]);   
                   int x = iBarShift(NULL,timeFrame,Time[i+displace]);            
                      Line1Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA,MAmode,MAprice,StepSizeFast,StepSizeSlow,FastSdvig,SlowSdvig,StepSmooth,StepSize,TotalBar,0,y);
                      Line2Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA,MAmode,MAprice,StepSizeFast,StepSizeSlow,FastSdvig,SlowSdvig,StepSmooth,StepSize,TotalBar,1,y);
                      Line3Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA,MAmode,MAprice,StepSizeFast,StepSizeSlow,FastSdvig,SlowSdvig,StepSmooth,StepSize,TotalBar,2,y);
                   if (x!=y)
                   {
                      Line4Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA,MAmode,MAprice,StepSizeFast,StepSizeSlow,FastSdvig,SlowSdvig,StepSmooth,StepSize,TotalBar,3,y);
                      Line5Buffer[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MA,MAmode,MAprice,StepSizeFast,StepSizeSlow,FastSdvig,SlowSdvig,StepSmooth,StepSize,TotalBar,4,y);   
                   }
               }
               return(0);
            }
   int shift,ftrend,strend;
   double fmin0,fmax0,fmin1,fmax1,smin0,smax0,smin1,smax1,MA0;
   double TotalBar=Bars-counted_bars;
    if(counted_bars>0)
      counted_bars--;
//   Limit;
   
  
   for(i=0;i<TotalBar;i++)
   {
      Line1Buffer[i]=MathRand()%1001;
      Line2Buffer[i]=MathRand()%1001;
      Line3Buffer[i]=MathRand()%1001;
   }
   
   for(shift=TotalBar;shift>=0;shift--)
   {	
   MA0=iMA(NULL,0,MA,0,MAmode,MAprice,shift);
   
	  fmax0=MA0+StepSize*StepSizeFast;
	  fmin0=MA0-StepSize*StepSizeFast;
	  	    
	  if (MA0>fmax1)  ftrend=1; 
	  if (MA0<fmin1)  ftrend=-1;

	  if(ftrend>0 && fmin0<fmin1) fmin0=fmin1;
	  if(ftrend<0 && fmax0>fmax1) fmax0=fmax1;
	  
	  smax0=MA0+StepSize*StepSizeSlow;
	  smin0=MA0-StepSize*StepSizeSlow;
		
	  if (MA0>smax1)  strend=1; 
	  if (MA0<smin1)  strend=-1;

	  if(strend>0 && smin0<smin1) smin0=smin1;
	  if(strend<0 && smax0>smax1) smax0=smax1;
	    
	  
	  Line1Buffer[shift]=MA0;
	  
	  if (ftrend>0) Line6Buffer[shift-FastSdvig]=fmin0+StepSizeFast;
	  if (ftrend<0) Line6Buffer[shift-FastSdvig]=fmax0-StepSizeFast;
	  
	  if (strend>0) Line7Buffer[shift-SlowSdvig]=smin0+StepSizeSlow;
	  if (strend<0) Line7Buffer[shift-SlowSdvig]=smax0-StepSizeSlow;
	  
	  fmin1=fmin0;
	  fmax1=fmax0;
	  smin1=smin0;
	  smax1=smax0;
	 }
	 
	 
	 	for(shift=TotalBar;shift>=0;shift--)
      {	
      Line2Buffer[shift]= iMAOnArray(Line6Buffer,0,StepSmooth,0,MODE_EMA,shift);
      Line3Buffer[shift]= iMAOnArray(Line7Buffer,0,StepSmooth,0,MODE_EMA,shift);
      }
	 
	 
	 
	 
	 
	 
	 
	 
	 for(shift=TotalBar;shift>=0;shift--)
   {	
	  if (Line2Buffer[shift+1]>Line3Buffer[shift+1] && Line2Buffer[shift+2]<=Line3Buffer[shift+2])
	     {
	     Line4Buffer[shift] = Line3Buffer[shift+1]-StepSizeFast;
	     }
	  if (Line2Buffer[shift+1]<Line3Buffer[shift+1] && Line2Buffer[shift+2]>=Line3Buffer[shift+2])
	     {
	     Line5Buffer[shift] = Line3Buffer[shift+1]+StepSizeFast;
	     }
	  
	 }
	 
	return(0);	
 }
 
 //-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}



